## $Id: product.py 12400 2015-01-05 07:22:08Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
These are the products (e.g. licenses).
"""
import grok
from zope.component.interfaces import IFactory
from zope.interface import implementedBy
from waeup.ikoba.utils.helpers import attrs_to_fields
from waeup.ikoba.products.product import Product
from ikobacustom.pcn.products.interfaces import IPCNProduct
from ikobacustom.pcn.interfaces import MessageFactory as _


class PCNProduct(Product):
    """This is a product.
    """
    grok.implements(IPCNProduct)
    grok.provides(IPCNProduct)

    form_fields_interface = IPCNProduct

PCNProduct = attrs_to_fields(PCNProduct)


class PCNProductFactory(grok.GlobalUtility):
    """A factory for products.
    """
    grok.implements(IFactory)
    grok.name(u'waeup.Product')
    title = u"Create a new product.",
    description = u"This factory instantiates new pcn products."

    def __call__(self, *args, **kw):
        return PCNProduct(*args, **kw)

    def getInterfaces(self):
        return implementedBy(PCNProduct)